﻿/*
 * Erstellt mit SharpDevelop.
 * Benutzer: Hauptnutzer
 * Datum: 21.04.2010
 * Zeit: 22:17
 * 
 * Sie können diese Vorlage unter Extras > Optionen > Codeerstellung > Standardheader ändern.
 */
using System;
using System.Drawing;

namespace AKFB_2._
{
	/// <summary>
	/// Description of graph.
	/// </summary>
	public class myGraph
	{
		
		public double[,] Matrix;
		public int Bildbreite, Bildhoehe;
		public int Bildrand;
		public int az, el;
		public double xmin, ymin, zmin, xmax, ymax, zmax;
		public bool ZeichneKoordSystem;
		
		
		
		public myGraph(int Bildbreite_ex, int Bildhoehe_ex)
		{ // Konstruktor
			Bildrand = 40;
			ZeichneKoordSystem = true;
			Bildbreite = Bildbreite_ex;
			Bildhoehe = Bildhoehe_ex;
		}
		
		public Bitmap createGraph(ref double[] Vektor)
		{
			int i,j;
			double[] Startpunkt, Endpunkt;
			Color pixelcolour;
			Startpunkt = new double[3];
			Endpunkt = new double[3];
			
			// Prüfung ob Bildbreite, Bildhoehe und Matrix existieren
			
			// Neue Bitmap erstellen,
			Bitmap Graph = new Bitmap(Bildbreite, Bildhoehe);
			
			// Bitmap mit Weiß füllen
			pixelcolour = Color.FromArgb(255,255,255,255);
			for (i = 0; i < Bildbreite; i++)
			{
				for (j = 0; j < Bildhoehe; j++)
				{
					Graph.SetPixel(i,j,pixelcolour);
				}
			}
			{
				// Grenzen anpassen
				xmin = 0;
				xmax = Vektor.Length;
				if (ymin == 0)
				{
					ymin = 2e99;
					for (i = 0; i < xmax; i++)
						if (Vektor[i] < ymin)
							ymin = Vektor[i];
				}
				if (ymax == 0)
				{
					ymax = -2e99;
					for (i = 0; i < xmax; i++)
						if (Vektor[i] > ymax)
							ymax = Vektor[i];
				}
				
				ymax = ymax + Math.Abs(ymax - ymin)*0.1;
				ymin = ymin - Math.Abs(ymax - ymin)*0.1;
			}
			Color Farbe;
			Farbe = Color.FromArgb(255,0,0,0);
			// Messwerte auftragen
			xmax = Vektor.Length-1;
			
			if (ZeichneKoordSystem == true)
			{
				Graph = createKoordSystem (ref Graph);
				Graph = beschrifteAchsen(ref Graph);
			}



			Farbe = Color.FromArgb(255,20,20,20);
			
			for ( i = 0 ; i < Vektor.Length -1 ; i++)
			{
				Startpunkt[0] = i;
				Startpunkt[1] = Vektor[i];
				Endpunkt[0] = i+1;
				Endpunkt[1] = Vektor[i+1];
				drawVektor(ref Graph, Startpunkt, Endpunkt, Farbe);
				//drawPunkt(ref Graph,Startpunkt,Farbe);
//				if (i == 2)
//					break;
			}
			
			
			//drawPunkt(ref Graph, Koordinaten, Farbe);
			//drawVektor(ref Graph, Koordinaten, Endpunkt,Farbe);
			
			// Matrix analysieren
			
			// Punkt auf Vektor
			
			
			return Graph;
		}
		
		private Bitmap createKoordSystem(ref Bitmap Graph)
		{
			double[] Startpunkt, Endpunkt;
			
			Startpunkt = new double[3];
			Endpunkt = new double[3];
			// X-Achse
			Startpunkt[0] = xmin;
			Startpunkt[1] = 0;
			Startpunkt[2] = 0;
			Endpunkt[0] = xmax;
			Endpunkt[1] = 0;
			Endpunkt[2] = 0;
			Color Farbe;
			Farbe = Color.FromArgb(255,0,0,0);
			Graph = drawVektor (ref Graph, Startpunkt, Endpunkt, Farbe);
			
			// Y-Achse zeichnen
			Startpunkt[0] = 0;
			Startpunkt[1] = ymin;
			Endpunkt[0] = 0;
			Endpunkt[1] = ymax;
			Graph = drawVektor(ref Graph, Startpunkt, Endpunkt, Farbe);
			
			return Graph;
		}
		
		private Bitmap drawVektor (ref Bitmap Graph, double[] Startpunkt, double[] Endpunkt, Color Farbe)
		{
			int i,j,k;
			double Auszug;
			double[] xVektor;
			double[] yVektor;
			double[] Richtung;
			int myXPixel;
			int myYPixel;
			int myXMin;
			int myXMax;
			int myYMin;
			int myYMax;
			xVektor = new double[Bildbreite-2*Bildrand+2];
			yVektor = new double[Bildhoehe -2*Bildrand+2];
			Richtung = new double[3];
			
			bool nichtfertig;
			nichtfertig = true;
			
			// Vektor erzeugen -- Vektor beschreibt Verschiebung
			// für Auslenkung in Bildebene
			for (i = 0 ; i < xVektor.Length; i++)
				xVektor[i] = xmin + ((double)xmax - (double)xmin) * (double)i / (double)xVektor.Length;
			
			for (j = 0 ; j < yVektor.Length; j++)
				yVektor[j] = ymin + ((double)ymax - (double)ymin) * (double)j / (double)yVektor.Length;

			
			// Wenn Vektor nach unten zeigt, Start & Endpunkt vertauschen
			if (Endpunkt[1] < Startpunkt[1])
			{
				for (i = 0; i < 3; i++)
				{
					Richtung[i] = Startpunkt[i];
					Startpunkt[i] = Endpunkt[i];
					Endpunkt[i] = Richtung[i];
				}
				
			}
			
			
			// Vektorrichtung bestimmen
			for (i = 0; i <3; i++)
				Richtung[i] = Endpunkt[i] - Startpunkt[i];
			
			
			// Wenn Anstieg mehr Richtung X
			// if ( Richtung[0] / (xmax - xmin)*(ymax - ymin) * (xVektor[1]-xVektor[0]) >= Richtung[1] * (yVektor[1]-yVektor[0]) )
			if ( Math.Abs( Richtung[0] / (xVektor[1]-xVektor[0]) ) >= Math.Abs (Richtung[1]/(yVektor[1]-yVektor[0]) ) )
			{
				// Allgemeine Vektordaten berechnen
				{// Minimale und maximale x-Position suchen
					myXMin = getVektorkoord(ref xVektor, ref Startpunkt[0]);
					myXMax = getVektorkoord(ref xVektor, ref Endpunkt[0]);
					if (myXMin > myXMax)
					{
						i = myXMin;
						myXMin = myXMax;
						myXMax = i;
					}
//						myXMin = Convert.ToInt16(Math.Floor(xmax));
//					if (myXMax > xmax)
//						myXMax = Convert.ToInt16(Math.Floor(xmax));
				}
				
				while (nichtfertig)
				{
					// Vektor in Pixelelemente zerlegen
					for (k = myXMin ; k <= myXMax-1; k++)
					{
						// Richtungsvektor verlängern

						// Auszug bestimmen
						Auszug = Startpunkt[1] + ( (xVektor[k] - Startpunkt[0]) * Richtung[1] / Richtung[0] );
						
						// Für jedes Vektorelement, Pixel zeichnen
						myXPixel = getVektorkoord(ref xVektor, ref xVektor[k]);
						myYPixel = getVektorkoord(ref yVektor, ref Auszug);
						
						
						Graph.SetPixel(Bildrand+myXPixel,Bildhoehe-Bildrand-myYPixel,Farbe);
						
					}
					nichtfertig = false;
				}
			}
			
			// Wenn Kante eher Richtung Y
			else
			{
				// Allgemeine Vektordaten berechnen
				{
					// Minimale und maximale x-Position suchen
					myYMin = getVektorkoord(ref yVektor, ref Startpunkt[1]);
					myYMax = getVektorkoord(ref yVektor, ref Endpunkt[1]);
				}
				
				
				while (nichtfertig)
				{
					// Vektor in Pixelelemente zerlegen
					for (k = myYMin ; k <= myYMax-1; k++)
					{
						// Richtungsvektor verlängern

						// Auszug bestimmen
						Auszug = Startpunkt[0] + ( (yVektor[k] - Startpunkt[1]) * Richtung[0] / Richtung[1] );
						
						// Für jedes Vektorelement, Pixel zeichnen
						myYPixel = getVektorkoord(ref yVektor, ref yVektor[k]);
						myXPixel = getVektorkoord(ref xVektor, ref Auszug);
						
						
						Graph.SetPixel(Bildrand+myXPixel,Bildhoehe-Bildrand-myYPixel,Farbe);
						
					}
					nichtfertig = false;
				}
			}
			
			
			
			
			
			
			
			return Graph;
		}
		
		private Bitmap beschrifteAchsen (ref Bitmap Graph)
		{
			int i;
			double x_groesstezahl, y_groesstezahl;
			double x_potenz, y_potenz;
			double[] Startpunkt;
			Startpunkt = new double[3];
			bool nichtfertig;
			
			
			// Größte Zahl suchen
			x_groesstezahl = Math.Max(Math.Abs(xmin),Math.Abs(xmax));
			y_groesstezahl = Math.Max(Math.Abs(ymin),Math.Abs(ymax));
			
			
			// Dekade suchen - etwas anpassen
			if ( Math.Log10(x_groesstezahl) - Math.Floor(Math.Log10(x_groesstezahl)) < 0.6)
			{
				x_potenz = Math.Floor(Math.Log10(x_groesstezahl))-1;
			}
			else
			{
				x_potenz = Math.Floor(Math.Log10(x_groesstezahl));
			}
			
			if ( Math.Log10(y_groesstezahl) - Math.Floor(Math.Log10(y_groesstezahl)) < 0.6)
			{
				y_potenz = Math.Floor(Math.Log10(y_groesstezahl))-1;
			}
			else
			{
				y_potenz = Math.Floor(Math.Log10(y_groesstezahl));
			}
			
			
			nichtfertig = true;
			//positive x-Achse
			Color Farbe;
			Farbe = Color.FromArgb(255,0,0,0);
			while (nichtfertig)
			{
				for ( i = 0 ; i < 100; i++ )
				{
					Startpunkt[0] =  Math.Pow( (double)10,(x_potenz)) *(double)i;
					Startpunkt[1] = 0;
					if (Startpunkt[0] > xmax)
						break;
					drawSenkrechteMarke(ref Graph, Startpunkt, Farbe);
					
				}
				nichtfertig = false;
			}
			// Negative X-Achse;
			nichtfertig = true;
			while (nichtfertig)
			{
				for ( i = 0 ; i < 100; i++ )
				{
					Startpunkt[0] =  Math.Pow( (double)10,(x_potenz)) *-(double)i;
					Startpunkt[1] = 0;
					if (Startpunkt[0] < -xmin)
					{
						break;
					}
					drawSenkrechteMarke(ref Graph, Startpunkt, Farbe);
					
				}
				nichtfertig = false;
			}
			
			// Positive Y-Achse
			nichtfertig = true;
			while (nichtfertig)
			{
				for ( i = 0 ; i < 100; i++ )
				{
					Startpunkt[1] =  Math.Pow( (double)10,(y_potenz)) *+(double)i;
					Startpunkt[0] = 0;
					if (Startpunkt[1] > ymax)
					{
						break;
					}
					drawWaagerechteMarke(ref Graph, Startpunkt, Farbe);

				}
				nichtfertig = false;
			}
			
			// Negative Y-Achse
			nichtfertig = true;
			while (nichtfertig)
			{
				for ( i = 0 ; i < 100; i++ )
				{
					Startpunkt[1] =  Math.Pow( (double)10,(y_potenz)) * (- (double)i);
					Startpunkt[0] = 0;
					if (Startpunkt[1] < ymin)
					{
						break;
					}
					drawWaagerechteMarke(ref Graph, Startpunkt, Farbe);

				}
				nichtfertig = false;
			}

			
			return Graph;
		}
		
		
		private Bitmap drawPunkt (ref Bitmap Graph, double[] Startpunkt, Color Farbe)
		{
			int i,j;
			double[] xVektor;
			double[] yVektor;
			int myXPixel;
			int myYPixel;
			xVektor = new double[Bildbreite-2*Bildrand];
			yVektor = new double[Bildhoehe -2*Bildrand];
			
			// Vektor erzeugen -- Vektor beschreibt Verschiebung
			// für Auslenkung in Bildebene
			for (i = 0 ; i < xVektor.Length; i++)
				xVektor[i] = xmin + ((double)xmax - (double)xmin) * (double)i / (double)xVektor.Length;
			
			for (j = 0 ; j < yVektor.Length; j++)
				yVektor[j] = ymin + ((double)ymax - (double)ymin) * (double)j / (double)yVektor.Length;
			
			
			
			// Suchen der Wertstelle im Vektor
			myXPixel = getVektorkoord(ref xVektor, ref Startpunkt[0]);
			myYPixel = getVektorkoord(ref yVektor, ref Startpunkt[1]);
			
			//myXPixel = 100;
			
			Graph.SetPixel(Bildrand+myXPixel,Bildhoehe-Bildrand-myYPixel,Farbe);
			
			return Graph;
		}

		private Bitmap drawSenkrechteMarke (ref Bitmap Graph, double[] Startpunkt, Color Farbe)
		{
			int i,j;
			double[] xVektor;
			double[] yVektor;
			int myXPixel;
			int myYPixel;
			xVektor = new double[Bildbreite-2*Bildrand];
			yVektor = new double[Bildhoehe -2*Bildrand];
			
			// Vektor erzeugen -- Vektor beschreibt Verschiebung
			// für Auslenkung in Bildebene
			for (i = 0 ; i < xVektor.Length; i++)
				xVektor[i] = xmin + ((double)xmax - (double)xmin) * (double)i / (double)xVektor.Length;
			
			for (j = 0 ; j < yVektor.Length; j++)
				yVektor[j] = ymin + ((double)ymax - (double)ymin) * (double)j / (double)yVektor.Length;
			
			
			
			// Suchen der Wertstelle im Vektor
			myXPixel = getVektorkoord(ref xVektor, ref Startpunkt[0]);
			myYPixel = getVektorkoord(ref yVektor, ref Startpunkt[1]);
			
			//myXPixel = 100;
			Graph.SetPixel(Bildrand+myXPixel,Bildhoehe-Bildrand-myYPixel-0,Farbe);
			Graph.SetPixel(Bildrand+myXPixel,Bildhoehe-Bildrand-myYPixel-1,Farbe);
			Graph.SetPixel(Bildrand+myXPixel,Bildhoehe-Bildrand-myYPixel-2,Farbe);
			Graph.SetPixel(Bildrand+myXPixel,Bildhoehe-Bildrand-myYPixel-3,Farbe);
			return Graph;
		}
		
		
		private Bitmap drawWaagerechteMarke (ref Bitmap Graph, double[] Startpunkt, Color Farbe)
		{
			int i,j;
			double[] xVektor;
			double[] yVektor;
			int myXPixel;
			int myYPixel;
			xVektor = new double[Bildbreite-2*Bildrand];
			yVektor = new double[Bildhoehe -2*Bildrand];
			
			// Vektor erzeugen -- Vektor beschreibt Verschiebung
			// für Auslenkung in Bildebene
			for (i = 0 ; i < xVektor.Length; i++)
				xVektor[i] = xmin + ((double)xmax - (double)xmin) * (double)i / (double)xVektor.Length;
			
			for (j = 0 ; j < yVektor.Length; j++)
				yVektor[j] = ymin + ((double)ymax - (double)ymin) * (double)j / (double)yVektor.Length;
			
			
			
			// Suchen der Wertstelle im Vektor
			myXPixel = getVektorkoord(ref xVektor, ref Startpunkt[0]);
			myYPixel = getVektorkoord(ref yVektor, ref Startpunkt[1]);
			
			//myXPixel = 100;
			Graph.SetPixel(Bildrand+myXPixel+0,Bildhoehe-Bildrand-myYPixel-1,Farbe);
			Graph.SetPixel(Bildrand+myXPixel+1,Bildhoehe-Bildrand-myYPixel-1,Farbe);
			Graph.SetPixel(Bildrand+myXPixel+2,Bildhoehe-Bildrand-myYPixel-1,Farbe);
			Graph.SetPixel(Bildrand+myXPixel+3,Bildhoehe-Bildrand-myYPixel-1,Farbe);
			return Graph;
		}
		
		
		private int getVektorkoord (ref double[] Vektor, ref double Koord)
		{
			int i;
			for (i = 0 ; i < Vektor.Length; i++)
				if (Vektor[i] > Koord)
					break;
			return i;
		}
		
	}
}
