﻿/*
 * Erstellt mit SharpDevelop.
 * Benutzer: Hauptnutzer
 * Datum: 16.04.2010
 * Zeit: 08:06
 * 
 * Sie können diese Vorlage unter Extras > Optionen > Codeerstellung > Standardheader ändern.
 */
using System;
using System.Drawing;

namespace AKFB_2._
{
	/// <summary>
	/// Description of mesh.
	/// </summary>

	
	
	public class mesh
	{
		
		//public double[,] Matrix;
		public int Bildbreite, Bildhoehe;
		public int Bildrand;
		private double xmin, ymin, xmax, ymax;
		public int el, az;
		//private myGraph FG;
		public bool tauscheXY_von_Matrix;
		public bool spiegleX_von_Matrix;
		public bool spiegleY_von_Matrix;
		public bool zeichneFlächen;
		public double pTransparenz;
		public double ZMIN, ZMAX;
		
		private double[] xVektor;
		private double[] yVektor;
		
		
		public mesh(int Bildbreite_ex, int Bildhoehe_ex)
		{ // Konstruktor
			Bildrand = 10;
			el = 90;
			az = 0;
			Bildbreite = Bildbreite_ex;
			Bildhoehe = Bildhoehe_ex;
			myGraph  FG = new myGraph(Bildbreite, Bildhoehe);
			FG.ZeichneKoordSystem = false;
			tauscheXY_von_Matrix = false;
			spiegleX_von_Matrix = false;
			spiegleY_von_Matrix = false;
			zeichneFlächen = false;
			ZMAX = 9e99;
			ZMIN = -9e99;
			pTransparenz = 0.7d;
			xVektor = new double[Bildbreite-2*Bildrand+2];
			yVektor = new double[Bildhoehe -2*Bildrand+2];
		}
		
		public Bitmap createmesh(double[,] Matrix)
		{
			int i,j;
			int[] matrixsize;

			
			double[] SP, EP;
			SP = new double[3];
			EP = new double[3];
			// Invertieren der Dimensionen x,y
			if (tauscheXY_von_Matrix)
				Matrix = tauschXYMatrix(ref Matrix);
			
			if (spiegleX_von_Matrix)
				Matrix = spiegleXMatrix(ref Matrix);
			
			if (spiegleY_von_Matrix)
				Matrix = spiegleYMatrix(ref Matrix);
			
			matrixsize = new int[2];
			matrixsize = getmatrixsize(ref Matrix);
			Color pixelcolour;
			
			// Prüfung ob Bildbreite, Bildhoehe und Matrix existieren
			
			// Neue Bitmap erstellen,
			Bitmap Graph = new Bitmap(Bildbreite, Bildhoehe);
			
			// Bitmap mit Weiß füllen
			pixelcolour = Color.FromArgb(255,255,255,255);
			for (i = 0; i < Bildbreite; i++)
			{
				for (j = 0; j < Bildhoehe; j++)
				{
					Graph.SetPixel(i,j,pixelcolour);
				}
			}
			
			
			Color Farbe;
			Farbe = Color.FromArgb(255,0,0,0);
			// Neuen Graph erzeugen
			
			// Graph skalieren, Achsen einzeichnen, Grid-Einzeichnen
			{
				// 8 Endpunkte des Zeichenraums berechnen
				double lokZMin;
				double lokZMax;
				{// Zmin und Zmax suchen
					
					if (ZMAX == 9e99)
					{
						lokZMax = getMaximaMatrix(ref Matrix);
						ZMAX = lokZMax;
					}

					else
						lokZMax = ZMAX;
					
					if (ZMIN == -9e99)
					{
						lokZMin = getMinimaMatrix(ref Matrix);
						ZMIN = lokZMin;
					}
					else
						lokZMin = ZMIN;
					
					
					
				}
				
				double[] p1, p2, p3, p4, p5, p6, p7, p8;
				p1 = new double[3];
				p2 = new double[3];
				p3 = new double[3];
				p4 = new double[3];
				p5 = new double[3];
				p6 = new double[3];
				p7 = new double[3];
				p8 = new double[3];
				
				p1[0] = 0;
				p1[1] = 0;
				p1[2] = lokZMin;
				p1 = transformKoord(p1);

				p2[0] = matrixsize[0];
				p2[1] = 0;
				p2[2] = lokZMin;
				p2 = transformKoord(p2);
				
				p3[0] = 0;
				p3[1] = matrixsize[1];
				p3[2] = lokZMin;
				p3 = transformKoord(p3);
				
				p4[0] = matrixsize[0];
				p4[1] = matrixsize[1];
				p4[2] = lokZMin;
				p4 = transformKoord(p4);
				
				p5[0] = 0;
				p5[1] = 0;
				p5[2] = lokZMax;
				p5 = transformKoord(p5);

				p6[0] = matrixsize[0];
				p6[1] = 0;
				p6[2] = lokZMax;
				p6 = transformKoord(p6);
				
				p7[0] = 0;
				p7[1] = matrixsize[1];
				p7[2] = lokZMax;
				p7 = transformKoord(p7);
				
				p8[0] = matrixsize[0];
				p8[1] = matrixsize[1];
				p8[2] = lokZMax;
				p8 = transformKoord(p8);
				
				if (xmin == 0)
					xmin =Math.Min( Math.Min(Math.Min(p1[0],p2[0]), Math.Min(p3[0],p4[0])), Math.Min(Math.Min(p5[0],p6[0]), Math.Min(p7[0],p8[0])));
				
				if (xmax == 0)
					xmax =Math.Max( Math.Max(Math.Max(p1[0],p2[0]), Math.Max(p3[0],p4[0])), Math.Max(Math.Max(p5[0],p6[0]), Math.Max(p7[0],p8[0])));
				if (ymin == 0)
					ymin =Math.Min( Math.Min(Math.Min(p1[1],p2[1]), Math.Min(p3[1],p4[1])), Math.Min(Math.Min(p5[1],p6[1]), Math.Min(p7[1],p8[1])));

				if (ymax == 0)
					ymax =Math.Max( Math.Max(Math.Max(p1[1],p2[1]), Math.Max(p3[1],p4[1])), Math.Max(Math.Max(p5[1],p6[1]), Math.Max(p7[1],p8[1])));
				
				erzeugeZeichenvektoren();
				
				// X-Achse einzeichnen
				if (p3[1] < p1[1]) // Wenn P3 weiter unten liegt
				{
					drawVektor(ref Graph, p3, p4, Farbe);
				}
				else
				{
					drawVektor(ref Graph, p1, p2, Farbe);
				}
				
				// Y-Achse zeichnen
				if (p1[1] < p2[1])
				{
					drawVektor(ref Graph, p1, p3, Farbe);
				}
				else
				{
					drawVektor(ref Graph, p2, p4, Farbe);
				}
				
				// Z-Achse zeichnen
				if ( (p1[0] < p2[0]) && (p1[0] < p3[0]) && (p1[0] < p4[0]) )
				{
					drawVektor(ref Graph, p1, p5, Farbe);
				}
				if ( (p2[0] < p1[0]) && (p2[0] < p3[0]) && (p2[0] < p4[0]) )
				{
					drawVektor(ref Graph, p2, p6, Farbe);
				}
				if ( (p3[0] < p2[0]) && (p3[0] <= p1[0]) && (p3[0] < p4[0]) )
				{
					drawVektor(ref Graph, p3, p7, Farbe);
				}
				if ( (p4[0] < p2[0]) && (p4[0] < p3[0]) && (p4[0] < p1[0]) )
				{
					drawVektor(ref Graph, p4, p8, Farbe);
				}
				
				
				
				// Einzeichnen des Punktmusters / Grid
				
				double  z_kleinstezahl, z_groesstezahl;
				double z_potenz;
				double[] Punkt, Punkt_temp;
				Punkt_temp = new double[3];
				Punkt = new double[3];
				
				
				// Größte Zahl suchen
				
				z_groesstezahl = ZMAX-ZMIN;
				z_kleinstezahl = ZMIN;
				int zGrid_Teiler;
				
				// Dekade suchen & etwas anpassen
				if ( Math.Log10(z_groesstezahl) - Math.Floor(Math.Log10(z_groesstezahl)) < 0.4)
				{
					zGrid_Teiler = 2;
					z_potenz = Math.Floor(Math.Log10(z_groesstezahl))-1;
				}
				else
				{
					zGrid_Teiler = 1;
					z_potenz = Math.Floor(Math.Log10(z_groesstezahl));
				}
				
				// Anzahl der Z-Striche berechnen
				double zSteps;
				for (zSteps = 1; zSteps < 100; zSteps++)
					if (Math.Pow( (double)10,(z_potenz)) *(double)zSteps > ZMAX)
						break;
				zSteps--;
				
				double[] Punkt1;
				double[] Punkt2;
				Punkt1  = new double[3];
				Punkt2  = new double[3];
				// Z-Stichelvektoren eintragen
				{

					

					
					// Suchen welcher der vier Grundpunkt in der hinteren
					// Ecke liegt (dann ist y in Grafik maximal)
					
					if ( (p1[1] > p2[1]) && (p1[1] > p3[1]) && (p1[1] > p4[1]) )
					{
						for (i = 0 ; i <= matrixsize[0]; i++)
						{
							Punkt1[0] = i;
							Punkt2[0] = i;
							Punkt1[1] = 0;
							Punkt2[1] = 0;
							Punkt1[2] = lokZMin;
							Punkt2[2] = lokZMax;
							Punkt1 = transformKoord(Punkt1);
							Punkt2 = transformKoord(Punkt2);
							drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
						}
						
						for (j = 0; j <= matrixsize[1]; j++)
						{
							Punkt1[0] = 0;
							Punkt2[0] = 0;
							Punkt1[1] = j;
							Punkt2[1] = j;
							Punkt1[2] = lokZMin;
							Punkt2[2] = lokZMax;
							Punkt1 = transformKoord(Punkt1);
							Punkt2 = transformKoord(Punkt2);
							drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
						}
					}
					if ( (p2[1] > p1[1]) && (p2[1] > p3[1]) && (p2[1] > p4[1]) )
					{
						for (i = 0 ; i <= matrixsize[0]; i++)
						{
							Punkt1[0] = i;
							Punkt2[0] = i;
							Punkt1[1] = 0;
							Punkt2[1] = 0;
							Punkt1[2] = lokZMin;
							Punkt2[2] = lokZMax;
							Punkt1 = transformKoord(Punkt1);
							Punkt2 = transformKoord(Punkt2);
							drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
						}
						
						for (j = 0; j <= matrixsize[1]; j++)
						{
							Punkt1[0] = matrixsize[0];
							Punkt2[0] = matrixsize[0];
							Punkt1[1] = j;
							Punkt2[1] = j;
							Punkt1[2] = lokZMin;
							Punkt2[2] = lokZMax;
							Punkt1 = transformKoord(Punkt1);
							Punkt2 = transformKoord(Punkt2);
							drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
						}
					}
					if ( (p3[1] > p2[1]) && (p3[1] > p1[1]) && (p3[1] > p4[1]) )
					{
						for (i = 0 ; i <= matrixsize[0]; i++)
						{
							Punkt1[0] = i;
							Punkt2[0] = i;
							Punkt1[1] = matrixsize[1];
							Punkt2[1] = matrixsize[1];
							Punkt1[2] = lokZMin;
							Punkt2[2] = lokZMax;
							Punkt1 = transformKoord(Punkt1);
							Punkt2 = transformKoord(Punkt2);
							drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
						}
						
						for (j = 0; j <= matrixsize[1]; j++)
						{
							Punkt1[0] = 0;
							Punkt2[0] = 0;
							Punkt1[1] = j;
							Punkt2[1] = j;
							Punkt1[2] = lokZMin;
							Punkt2[2] = lokZMax;
							Punkt1 = transformKoord(Punkt1);
							Punkt2 = transformKoord(Punkt2);
							drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
						}
						
						
					}
					if ( (p4[1] > p2[1]) && (p4[1] > p3[1]) && (p4[1] > p1[1]) )
					{
						
						for (i = 0 ; i <= matrixsize[0]; i++)
						{
							Punkt1[0] = i;
							Punkt2[0] = i;
							Punkt1[1] = matrixsize[1];
							Punkt2[1] = matrixsize[1];
							Punkt1[2] = lokZMin;
							Punkt2[2] = lokZMax;
							Punkt1 = transformKoord(Punkt1);
							Punkt2 = transformKoord(Punkt2);
							drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
						}
						
						for (j = 0; j <= matrixsize[1]; j++)
						{
							Punkt1[0] = matrixsize[0];
							Punkt2[0] = matrixsize[0];
							Punkt1[1] = j;
							Punkt2[1] = j;
							Punkt1[2] = lokZMin;
							Punkt2[2] = lokZMax;
							Punkt1 = transformKoord(Punkt1);
							Punkt2 = transformKoord(Punkt2);
							drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
						}
					}
				}
				
				
				
				
				
				
				
				{ // Y-Strichelvektoren eintragen
					if ( (p1[1] > p2[1]) && (p1[1] > p3[1]) && (p1[1] > p4[1]) )
					{
						for (i = 0 ; i <= zSteps; i++)
						{
							if ( (i % zGrid_Teiler == 0 ) || (i == zSteps) )
							{
								Punkt1[0] = 0;
								Punkt2[0] = 0;
								Punkt1[1] = 0;
								Punkt2[1] = matrixsize[1];
								Punkt1[2] = Math.Pow( (double)10,(z_potenz)) *(double)i;
								Punkt2[2] = Math.Pow( (double)10,(z_potenz)) *(double)i;
								Punkt1 = transformKoord(Punkt1);
								Punkt2 = transformKoord(Punkt2);
								drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
							}
						}
						
						for (j = 0; j <= matrixsize[0]; j++)
						{
							Punkt1[0] = j;
							Punkt2[0] = j;
							Punkt1[1] = 0;
							Punkt2[1] = matrixsize[1];
							Punkt1[2] = lokZMin;
							Punkt2[2] = lokZMin;
							Punkt1 = transformKoord(Punkt1);
							Punkt2 = transformKoord(Punkt2);
							drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
						}
					}
					if ( (p2[1] > p1[1]) && (p2[1] > p3[1]) && (p2[1] > p4[1]) )
					{
						for (i = 0 ; i <= zSteps; i++)
						{
							if ( (i % zGrid_Teiler == 0 ) || (i == zSteps) )
							{
								Punkt1[0] = matrixsize[0];
								Punkt2[0] = matrixsize[0];
								Punkt1[1] = 0;
								Punkt2[1] = matrixsize[1];
								Punkt1[2] = Math.Pow( (double)10,(z_potenz)) *(double)i;
								Punkt2[2] = Math.Pow( (double)10,(z_potenz)) *(double)i;
								Punkt1 = transformKoord(Punkt1);
								Punkt2 = transformKoord(Punkt2);
								drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
							}
						}
						
						for (j = 0; j <= matrixsize[0]; j++)
						{
							Punkt1[0] = j;
							Punkt2[0] = j;
							Punkt1[1] = 0;
							Punkt2[1] = matrixsize[1];
							Punkt1[2] = lokZMin;
							Punkt2[2] = lokZMin;
							Punkt1 = transformKoord(Punkt1);
							Punkt2 = transformKoord(Punkt2);
							drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
						}
					}
					if ( (p3[1] > p2[1]) && (p3[1] > p1[1]) && (p3[1] > p4[1]) )
					{
						for (i = 0 ; i <= zSteps; i++)
						{
							if ( (i % zGrid_Teiler == 0 ) || (i == zSteps) )
							{
								Punkt1[0] = 0;
								Punkt2[0] = 0;
								Punkt1[1] = 0;
								Punkt2[1] = matrixsize[1];
								Punkt1[2] = Math.Pow( (double)10,(z_potenz)) *(double)i;
								Punkt2[2] = Math.Pow( (double)10,(z_potenz)) *(double)i;
								Punkt1 = transformKoord(Punkt1);
								Punkt2 = transformKoord(Punkt2);
								drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
							}
						}
						
						for (j = 0; j <= matrixsize[0]; j++)
						{
							Punkt1[0] = j;
							Punkt2[0] = j;
							Punkt1[1] = 0;
							Punkt2[1] = matrixsize[1];
							Punkt1[2] = lokZMin;
							Punkt2[2] = lokZMin;
							Punkt1 = transformKoord(Punkt1);
							Punkt2 = transformKoord(Punkt2);
							drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
						}
						
						
					}
					if ( (p4[1] > p2[1]) && (p4[1] > p3[1]) && (p4[1] > p1[1]) )
					{
						for (i = 0 ; i <= zSteps; i++)
						{
							if ( (i % zGrid_Teiler == 0 ) || (i == zSteps) )
							{
								Punkt1[0] = matrixsize[0];
								Punkt2[0] = matrixsize[0];
								Punkt1[1] = 0;
								Punkt2[1] = matrixsize[1];
								Punkt1[2] = Math.Pow( (double)10,(z_potenz)) *(double)i;
								Punkt2[2] = Math.Pow( (double)10,(z_potenz)) *(double)i;
								Punkt1 = transformKoord(Punkt1);
								Punkt2 = transformKoord(Punkt2);
								drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
							}
						}
						
						for (j = 0; j <= matrixsize[0]; j++)
						{
							Punkt1[0] = j;
							Punkt2[0] = j;
							Punkt1[1] = 0;
							Punkt2[1] = matrixsize[1];
							Punkt1[2] = lokZMin;
							Punkt2[2] = lokZMin;
							Punkt1 = transformKoord(Punkt1);
							Punkt2 = transformKoord(Punkt2);
							drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
						}
					}
					
					
					

				}
				
				
				{ // X-Strichelvektoren erzeugen
					
					if ( (p1[1] > p2[1]) && (p1[1] > p3[1]) && (p1[1] > p4[1]) )
					{
						for (i = 0 ; i <= zSteps; i++)
						{
							if ( (i % zGrid_Teiler == 0 ) || (i == zSteps) )
							{
								Punkt1[0] = 0;
								Punkt2[0] = matrixsize[0];
								Punkt1[1] = 0;
								Punkt2[1] = 0;
								Punkt1[2] = Math.Pow( (double)10,(z_potenz)) *(double)i;
								Punkt2[2] = Math.Pow( (double)10,(z_potenz)) *(double)i;
								Punkt1 = transformKoord(Punkt1);
								Punkt2 = transformKoord(Punkt2);
								drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
							}
						}
						
						for (j = 0; j <= matrixsize[1]; j++)
						{
							Punkt1[0] = 0;
							Punkt2[0] = matrixsize[0];
							Punkt1[1] = j;
							Punkt2[1] = j;
							Punkt1[2] = lokZMin;
							Punkt2[2] = lokZMin;
							Punkt1 = transformKoord(Punkt1);
							Punkt2 = transformKoord(Punkt2);
							drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
						}
					}
					if ( (p2[1] > p1[1]) && (p2[1] > p3[1]) && (p2[1] > p4[1]) )
					{
						for (i = 0 ; i <= zSteps; i++)
						{
							if ( (i % zGrid_Teiler == 0 ) || (i == zSteps) )
							{
								Punkt1[0] = 0;
								Punkt2[0] = matrixsize[0];
								Punkt1[1] = 0;
								Punkt2[1] = 0;
								Punkt1[2] = Math.Pow( (double)10,(z_potenz)) *(double)i;
								Punkt2[2] = Math.Pow( (double)10,(z_potenz)) *(double)i;
								Punkt1 = transformKoord(Punkt1);
								Punkt2 = transformKoord(Punkt2);
								drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
							}
						}
						
						for (j = 0; j <= matrixsize[1]; j++)
						{
							Punkt1[0] = 0;
							Punkt2[0] = matrixsize[0];
							Punkt1[1] = j;
							Punkt2[1] = j;
							Punkt1[2] = lokZMin;
							Punkt2[2] = lokZMin;
							Punkt1 = transformKoord(Punkt1);
							Punkt2 = transformKoord(Punkt2);
							drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
						}
					}
					
					if ( (p3[1] > p2[1]) && (p3[1] > p1[1]) && (p3[1] > p4[1]) )
					{
						for (i = 0 ; i <= zSteps; i++)
						{
							if ( (i % zGrid_Teiler == 0 ) || (i == zSteps) )
							{
								Punkt1[0] = 0;
								Punkt2[0] = matrixsize[0];
								Punkt1[1] = matrixsize[1];
								Punkt2[1] = matrixsize[1];
								Punkt1[2] = Math.Pow( (double)10,(z_potenz)) *(double)i;
								Punkt2[2] = Math.Pow( (double)10,(z_potenz)) *(double)i;
								Punkt1 = transformKoord(Punkt1);
								Punkt2 = transformKoord(Punkt2);
								drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
							}
						}
						
						for (j = 0; j <= matrixsize[1]; j++)
						{
							Punkt1[0] = 0;
							Punkt2[0] = matrixsize[0];
							Punkt1[1] = j;
							Punkt2[1] = j;
							Punkt1[2] = lokZMin;
							Punkt2[2] = lokZMin;
							Punkt1 = transformKoord(Punkt1);
							Punkt2 = transformKoord(Punkt2);
							drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
						}
					}
					if ( (p4[1] > p2[1]) && (p4[1] > p3[1]) && (p4[1] > p1[1]) )
					{
						for (i = 0 ; i <= zSteps; i++)
						{
							if ( (i % zGrid_Teiler == 0 ) || (i == zSteps) )
							{
								Punkt1[0] = 0;
								Punkt2[0] = matrixsize[0];
								Punkt1[1] = matrixsize[1];
								Punkt2[1] = matrixsize[1];
								Punkt1[2] = Math.Pow( (double)10,(z_potenz)) *(double)i;
								Punkt2[2] = Math.Pow( (double)10,(z_potenz)) *(double)i;
								Punkt1 = transformKoord(Punkt1);
								Punkt2 = transformKoord(Punkt2);
								drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
							}
						}
						
						for (j = 0; j <= matrixsize[1]; j++)
						{
							Punkt1[0] = 0;
							Punkt2[0] = matrixsize[0];
							Punkt1[1] = j;
							Punkt2[1] = j;
							Punkt1[2] = lokZMin;
							Punkt2[2] = lokZMin;
							Punkt1 = transformKoord(Punkt1);
							Punkt2 = transformKoord(Punkt2);
							drawVektorPunktLochLochLoch(ref Graph, Punkt1, Punkt2, Farbe);
						}
					}

					
				}
			}
			
			double[] P1, P2, P3;
			P1 = new double[3];
			P2 = new double[3];
			P3 = new double[3];
//
//			P1[0] = 1;
//			P1[1] = 1;
//			P1[2] = 0;
//			P2[0] = 0;
//			P2[1] = 1;
//			P2[2] = 0;
//			P3[0] = 1;
//			P3[1] = 0;
//			P3[2] = 0;
//			P1 = transformKoord(P1);
//			P2 = transformKoord(P2);
//			P3 = transformKoord(P3);
//			Farbe = Color.FromArgb(255, 255, 128, 0);
//			zeichneDreieck(ref Graph, P3, P2, P1, Farbe, 0.5d);
//			//Farbe = Color.FromArgb(255,0,0,0);
//			P1[0] = 1;
//			P1[1] = 1;
//			P1[2] = 0;
//			P2[0] = 0;
//			P2[1] = 1;
//			P2[2] = 0;
//			P3[0] = 1;
//			P3[1] = 0;
//			P3[2] = 0;
//			P1 = transformKoord(P1);
//			P2 = transformKoord(P2);
//			P3 = transformKoord(P3);
//			drawVektor(ref Graph, P1, P2, Farbe);
//						P1[0] = 1;
//			P1[1] = 1;
//			P1[2] = 0;
//			P2[0] = 0;
//			P2[1] = 1;
//			P2[2] = 0;
//			P3[0] = 1;
//			P3[1] = 0;
//			P3[2] = 0;
//			P1 = transformKoord(P1);
//			P2 = transformKoord(P2);
//			P3 = transformKoord(P3);
//			drawVektor(ref Graph, P2, P3, Farbe);
//						P1[0] = 1;
//			P1[1] = 1;
//			P1[2] = 0;
//			P2[0] = 0;
//			P2[1] = 1;
//			P2[2] = 0;
//			P3[0] = 1;
//			P3[1] = 0;
//			P3[2] = 0;
//			P1 = transformKoord(P1);
//			P2 = transformKoord(P2);
//			P3 = transformKoord(P3);
//			drawVektor(ref Graph, P1, P3, Farbe);
			
			
			
			if (zeichneFlächen)
			{// Zeichnen der Flächen

				for (i = matrixsize[0] ; i > 0; i--)
				{
					for (j = 0 ; j < matrixsize[1]; j++)
					{
						// Dreieck1 zeichnen
						Farbe = Color.FromArgb(255,255,0,0);
						P1[0] = i-1;
						P1[1] = j;
						P1[2] = Matrix[i-1,j];
						P2[0] = i;
						P2[1] = j;
						P2[2] = Matrix[i,j];
						P3[0] = i-1;
						P3[1] = j+1;
						P3[2] = Matrix[i-1,j+1];
						
						// Farbe berechnen
						Farbe = gebeFarbe((P1[2] + P2[2] + P3[2] + Matrix[i,j+1])/4);
						
						P1 = transformKoord(P1);
						P2 = transformKoord(P2);
						P3 = transformKoord(P3);
						
						//Farbe = Color.FromArgb(255,0,0,0);
						Graph = zeichneDreieck(ref Graph, P2,P1,P3,Farbe,pTransparenz);
						
						
						// Dreieck 2 zeichnen
						P1[0] = i;
						P1[1] = j+1;
						P1[2] = Matrix[i,j+1];
						P2[0] = i;
						P2[1] = j;
						P2[2] = Matrix[i,j];
						P3[0] = i-1;
						P3[1] = j+1;
						P3[2] = Matrix[i-1,j+1];
						P1 = transformKoord(P1);
						P2 = transformKoord(P2);
						P3 = transformKoord(P3);
						//Color.FromArgb(255,0,255,0);
						Graph = zeichneDreieck(ref Graph, P1,P2,P3,Farbe,pTransparenz);
						
					}
				}
			}
			
			

			{// Einscheiben der Matrix ins Bild
				Farbe = Color.FromArgb(255,0,0,0);
				for (i = 0 ; i <= matrixsize[0]; i++)
				{
					for (j = 0 ; j <= matrixsize[1]; j++)
					{
						// Linien entlang der ERSTEN Dimension
						// Abbruch wenn j am Limit
						if (j != matrixsize[1])
						{
							SP[0] = i;
							SP[1] = j;
							SP[2] = Matrix[i,j];
							EP[0] = i;
							EP[1] = j + 1;
							EP[2] = Matrix[i,j+1];
							//Farbe = gebeFarbe((EP[2] + SP[2])/2);
							SP = transformKoord(SP);
							EP = transformKoord(EP);


							drawVektor(ref Graph, SP, EP, Farbe);
						}

						// Linien entlang der ZWEITEN Dimension
						// Abbruch wenn i am Limit
						if (i != matrixsize[0])
						{
							SP[0] = i;
							SP[1] = j;
							SP[2] = Matrix[i,j];
							EP[0] = i+1;
							EP[1] = j;
							EP[2] = Matrix[i+1,j];
							//Farbe = gebeFarbe((EP[2] + SP[2])/2);
							SP = transformKoord(SP);
							EP = transformKoord(EP);

							drawVektor(ref Graph, SP, EP, Farbe);
						}

					}
				}

			}
			
			return Graph;
		}
		
		private Bitmap zeichneKontur(ref Bitmap Graph, double[,] Matrix, double[] Klinen)
		{
						return Graph;
		}
		
		private void erzeugeZeichenvektoren ()
		{
			int i, j;
			for (i = 0 ; i < xVektor.Length; i++)
				xVektor[i] = xmin + ((double)xmax - (double)xmin) * (double)i / (double)xVektor.Length;
			
			for (j = 0 ; j < yVektor.Length; j++)
				yVektor[j] = ymin + ((double)ymax - (double)ymin) * (double)j / (double)yVektor.Length;
			
		}
		
		private Bitmap zeichneDreieck (ref Bitmap Graph, double[] P1, double[] P2, double[] P3, Color Farbe, double Transparenz)
		{
			// Transparenz sollte Wert zwischen 0 und 1 sein
			
			byte[] myColorarray;
			byte[] myPaintcolor;
			
			int i,j,k;
			int myXMin, myXMax, myYMin, myYMax;
			int[] p1, p2, p3;
			int[,] myArea;
			
			

			
			Color pixelcolor;
			//myColorarray = new byte[3];
			myPaintcolor = new byte[3];
			
			myPaintcolor[0] = Farbe.R;
			myPaintcolor[1] = Farbe.G;
			myPaintcolor[2] = Farbe.B;

			p1 = new int[2];
			p2 = new int[2];
			p3 = new int[2];
			

			// Dreieckspunkte in Bitmap-Koordinaten umrechnen
			p1[0] = getVektorkoord(ref xVektor, ref P1[0]);
			p1[1] = getVektorkoord(ref yVektor, ref P1[1]);
			p2[0] = getVektorkoord(ref xVektor, ref P2[0]);
			p2[1] = getVektorkoord(ref yVektor, ref P2[1]);
			p3[0] = getVektorkoord(ref xVektor, ref P3[0]);
			p3[1] = getVektorkoord(ref yVektor, ref P3[1]);
			
			
			
			//Punkte so vertauschen, dass P1 links liegt
			int[] p4;
			p4 = new int[2];

			if (p1[0] > p2[0])
			{
				for (i = 0; i<2;i++)
					p4[i] = p1[i];

				for (i = 0; i<2;i++)
					p1[i] = p2[i];
				for (i = 0; i<2;i++)
					p2[i] = p4[i];
			}
			if (p1[0] > p3[0])
			{
				for (i = 0; i<2;i++)
					p4[i] = p1[i];

				for (i = 0; i<2;i++)
					p1[i] = p3[i];
				for (i = 0; i<2;i++)
					p3[i] = p4[i];
			}
			
			

			
			// Minimale x & y Bitmap Koord sowie max. x & y Koordinate berechnen
			myXMin = Math.Min ( Math.Min(p1[0], p2[0]), p3[0] );
			myXMax = Math.Max ( Math.Max(p1[0], p2[0]), p3[0] );
			myYMin = Math.Min ( Math.Min(p1[1], p2[1]), p3[1] );
			myYMax = Math.Max ( Math.Max(p1[1], p2[1]), p3[1] );
			
			myArea = new int[myXMax - myXMin +1,myYMax - myYMin+1];
			
			
			// Berechnung der Winkel zwischen den Dreieckspunkten
			// Zu Behandlung des Phasensprunges, genauere Aufteilung
			double t1a1, t2a1, t1a2, t2a2;
			double tb1, tb2;
			double ps1, ps2;
			t1a1 = Math.Atan2( p1[0] - p2[0], p1[1] - p2[1]);
			t2a1 = Math.Atan2( p1[0] - p3[0], p1[1] - p3[1]);
			t1a2 = Math.Atan2( p2[0] - p3[0], p2[1] - p3[1]);
			t2a2 = Math.Atan2( p2[0] - p1[0], p2[1] - p1[1]);
			ps1 = 0;
			ps2 = 0;
			
			// Erkennung des Phasensprunges für a1 (erster Winkel)
			if ( t1a1 - t2a1 > Math.PI)  // t1a1 pos, t2a1 neg.
				ps1 = 1;
			if ( t1a1 - t2a1 < - Math.PI) // t1a1 neg, t2a1 pos
				ps1 = -1;
			if ( ( -Math.PI < t1a1 - t2a1 ) && ( ( t1a1 - t2a1 ) < Math.PI ) )
				ps1 = 0; // Winkel überstreicht Phasensprung nicht
			
			// Das gleich für a2 (zweiter Winkel)
			if ( t1a2 - t2a2 > Math.PI)  // t1a2 pos, t2a2 neg.
				ps2 = 1;
			if ( t1a2 - t2a2 < - Math.PI) // t1a2 neg, t2a2 pos
				ps2 = -1;
			if ( ( -Math.PI < t1a2 - t2a2 ) && (( t1a2 - t2a2 ) < Math.PI ) )
				ps2 = 0; // Winkel überstreicht Phasensprung nicht

			// Erstmal die Möglichkeit einer Existenz in die Matrix schreiben
			for (i = 0; i <= myXMax-myXMin; i++)
			{
				for (j = 0; j <= myYMax-myYMin; j++)
				{
					// Winkel des Punktes zu P1 berechnen
					tb1 = Math.Atan2(p1[0] - i-myXMin, p1[1] - j-myYMin);
					
					// Je nach Phasensprung zwischen t1a1 und t2a2 -> unterschiedl.
					// Kriterien
					if (ps1 == 0)
						if ( (tb1 >= Math.Min (t1a1,t2a1) ) && (tb1 <= Math.Max(t1a1,t2a1) ) )
							myArea[i,j]++;
					if (ps1 == 1)
						if ( (tb1 >= t1a1) || (tb1 <= t2a1) )
							myArea[i,j]++;
					if (ps1 == -1)
						if ( (tb1 <= t1a1) || (tb1 >= t2a1 ) )
							myArea[i,j]++;

					// Nächster Pixel, wenn schon nicht im Winkelbereich des
					// ersten Ecks liegt
					if (myArea[i,j] == 0)
						continue;
					
					// Winkel des Punktes zu P2
					tb2 = Math.Atan2(+p2[0] - i-myXMin, +p2[1] - j-myYMin);
					
					// Jetzt wieder die Kriterien, je nach Phasensprung
					if (ps2 == 0)
						if ( (tb2 >= Math.Min (t1a2,t2a2) ) && (tb2 <= Math.Max(t1a2,t2a2) ) )
							myArea[i,j]++;
					if (ps2 == 1)
						if ( (tb2 >= t1a2) || (tb2 <= t2a2) )
							myArea[i,j]++;
					if (ps2 == -1)
						if ( (tb2 <= t1a2) || (tb2 >= t2a2 ) )
							myArea[i,j]++;
					
				}
			}
			//int testtemp;
			myColorarray = new byte[3];
			// Stellen, an welchen myArea == 2 -> Graph ändern
			for (i = 0; i <= myXMax-myXMin; i++)
			{
				for (j = 0; j <= myYMax-myYMin; j++)
				{
					if (myArea[i,j] == 2)
					{
						// !!! Hier muss noch die Transparenz eingefügt werden !!!
						pixelcolor = Graph.GetPixel(Bildrand+i+myXMin,Bildhoehe-Bildrand-(j+myYMin));
						myColorarray[0] = pixelcolor.R;
						myColorarray[1] = pixelcolor.G;
						myColorarray[2] = pixelcolor.B;
						for ( k = 0; k <3; k++)
						{
							//testtemp = Convert.ToInt16(myPaintcolor[k] * Transparenz + myColorarray[k] * (1-Transparenz) );
							myColorarray[k] = Convert.ToByte(myPaintcolor[k] * Transparenz + myColorarray[k] * (1-Transparenz) );
						}
						
						Graph.SetPixel(Bildrand+i+myXMin,Bildhoehe-Bildrand-(j+myYMin),Color.FromArgb(255, myColorarray[0], myColorarray[1], myColorarray[2]));
					}
				}
			}
			
			


			
			return Graph;
		}
		
		
		private Color gebeFarbe(double ZMittel)
		{
			
			// Man nehme:
			//			- einen Cosinus y = cos(x)
			//        davon nur eine halbe Periode
			//			- Definiere y = -1 als rot
			//			  					y = 0  als grün
			//									y = 1  als blau
			
			double myZBetrag;
			myZBetrag = ZMAX - ZMIN;
			double rot, gruen, blau;
			// Wenn unterhalb von ZMIN -> Blau
			if (ZMittel < ZMIN)
				return Color.FromArgb(255, 0, 0, 128);
			if (ZMittel > ZMAX)
				return Color.FromArgb(255,128,0,0);
			
			
			
			// Farbschema
			blau = 0;
			rot = 0;
			gruen = 0;
			if ( (ZMittel / (myZBetrag - ZMIN)) <= 0.4 )
			{
				blau = Math.Min(255, (ZMittel / (myZBetrag - ZMIN)) *637.5 + 128);
				gruen = Math.Max (0, (ZMittel / (myZBetrag - ZMIN)) * 1274 - 255);
				rot = 0;
			}
			if ( ( (ZMittel / (myZBetrag - ZMIN)) > 0.4 ) && ( (ZMittel / (myZBetrag - ZMIN)) < 0.6 ) )
			{
				blau = Math.Max(0, -(ZMittel / (myZBetrag - ZMIN)) * 1275 + 765);
				gruen = 255;
				rot = Math.Max(0, (ZMittel / (myZBetrag - ZMIN))*1275 - 510);
			}
			
			if ( (ZMittel / (myZBetrag - ZMIN)) >= 0.6 )
			{
				rot = Math.Min(255, (ZMittel / (myZBetrag - ZMIN)) *1275/2+765);
				gruen = Math.Max (0, -(ZMittel / (myZBetrag - ZMIN)) *1275+1020);
				blau = 0;
			}


			
			
			return Color.FromArgb(255, (int)rot, (int)gruen, (int)blau);
			
			
		}

		private Bitmap zeichnePunktmuster (ref Bitmap Graph, int[] matrixsize)
		{
			int i,j;
			double  z_kleinstezahl, z_groesstezahl;
			double z_potenz;
			double[] Punkt, Punkt_temp;
			Punkt_temp = new double[3];
			Punkt = new double[3];
			
			
			// Größte Zahl suchen
			
			z_groesstezahl = ZMAX-ZMIN;
			z_kleinstezahl = ZMIN;
			
			
			// Dekade suchen & etwas anpassen
			if ( Math.Log10(z_groesstezahl) - Math.Floor(Math.Log10(z_groesstezahl)) < 0.6)
			{
				z_potenz = Math.Floor(Math.Log10(z_groesstezahl))-1;
			}
			else
			{
				z_potenz = Math.Floor(Math.Log10(z_groesstezahl));
			}

			// Z-Y Ebene rastern
			{
				Color Farbe1, Farbe2;
				Farbe1 = Color.FromArgb (255, 180, 180, 180);
				Farbe2 = Color.FromArgb (255, 070, 070, 070);
				
				Punkt[0] = matrixsize[0];
				for (j = 0 ; j < matrixsize[1]*1 ; j++)
				{
					Punkt[1] = (double)j/1;
					for ( i = 1 ; i < 1000; i++ )
					{
						Punkt[2] =  Math.Pow( (double)10,(z_potenz)) *(double)i / 1;
						if (Punkt[2] > ZMAX)
							break;
						Punkt_temp = transformKoord(Punkt);
						if ( (j % 1 == 0) && (i % 1 == 0) )
							drawPunkt(ref Graph, Punkt_temp,Farbe2);
						else
							drawPunkt(ref Graph, Punkt_temp,Farbe1);
						
					}
				}
			}

			
			// Z-X Ebene rastern
			{
				Color Farbe;
				Farbe = Color.FromArgb (255, 100, 100, 100);
				
				Punkt[1] = matrixsize[1];
				for (j = 0 ; j < matrixsize[0] ; j++)
				{
					Punkt[0] = j;
					for ( i = 1 ; i < 100; i++ )
					{
						Punkt[2] =  Math.Pow( (double)10,(z_potenz)) *(double)i;
						if (Punkt[2] > ZMAX)
							break;
						Punkt_temp = transformKoord(Punkt);
						drawPunkt(ref Graph, Punkt_temp,Farbe);
					}
				}
				
				// XY Ebene punkten
				Punkt[2] = ZMIN;
				for (i = 0; i < matrixsize[0]; i++)
				{
					Punkt[0] = i;
					
					for (j = 0 ; j < matrixsize[1] ; j++)
					{
						Punkt[1] = j;
						Punkt_temp = transformKoord(Punkt);
						drawPunkt(ref Graph, Punkt_temp, Farbe);
						
					}
				}
			}
			
			return Graph;
		}
		
		
		private double getMaximaMatrix( ref double[,] Matrix)
		{
			double Maximum;
			int i,j;
			int[] matrixsize;
			matrixsize = new int[2];
			matrixsize = getmatrixsize(ref Matrix);
			
			Maximum = -9e99;
			
			for ( i = 0 ; i <= matrixsize[0]; i++)
			{
				for (j=0; j <= matrixsize[1] ; j++)
				{
					if (Matrix[i,j] > Maximum)
						Maximum = Matrix[i,j];
				}
			}
			return Maximum;
		}
		
		private double getMinimaMatrix( ref double[,] Matrix)
		{
			double Minimum;
			int i,j;
			int[] matrixsize;
			matrixsize = new int[2];
			matrixsize = getmatrixsize(ref Matrix);
			
			Minimum = 9e99;
			
			for ( i = 0 ; i <= matrixsize[0]; i++)
			{
				for (j=0; j <= matrixsize[1] ; j++)
				{
					if (Matrix[i,j] < Minimum)
						Minimum = Matrix[i,j];
				}
			}
			return Minimum;
		}
		
		private double[,] spiegleXMatrix (ref double[,] Matrix)
		{
			int i,j;
			int[] matrixsize;
			matrixsize = new int[2];
			matrixsize = getmatrixsize(ref Matrix);
			
			double[,] retMatrix;
			retMatrix = new double[matrixsize[0]+1,matrixsize[1] + 1];
			
			for ( i = 0 ; i <= matrixsize[0]; i++)
			{
				for (j=0; j <= matrixsize[1] ; j++)
				{
					retMatrix[i,matrixsize[1]-j] = Matrix[i,j];
				}
			}
			return retMatrix;
			
			
		}
		
		
		private double[,] spiegleYMatrix (ref double[,] Matrix)
		{
			int i,j;
			int[] matrixsize;
			matrixsize = new int[2];
			matrixsize = getmatrixsize(ref Matrix);
			
			double[,] retMatrix;
			retMatrix = new double[matrixsize[0]+1,matrixsize[1] + 1];
			
			for ( i = 0 ; i <= matrixsize[0]; i++)
			{
				for (j=0; j <= matrixsize[1] ; j++)
				{
					retMatrix[matrixsize[0]-i,j] = Matrix[i,j];
				}
			}
			return retMatrix;
			
			
		}
		
		private double[,] tauschXYMatrix(ref double[,] Matrix)
		{
			int i,j;
			int[] matrixsize;
			matrixsize = new int[2];
			matrixsize = getmatrixsize(ref Matrix);
			
			double[,] retMatrix;
			retMatrix = new double[matrixsize[1]+1,matrixsize[0] + 1];
			
			for ( i = 0 ; i <= matrixsize[0]; i++)
			{
				for (j=0; j <= matrixsize[1] ; j++)
				{
					retMatrix[j,i] = Matrix[i,j];
				}
			}
			return retMatrix;
		}
		
		private double[] tauscheYZ (ref double[] Koord)
		{
			double temp;
			temp = Koord[2];
			Koord[2] = Koord[1];
			Koord[1] = temp;
			return Koord;
		}
		
		private double[] transformKoord (double[] Koord)
		{ // Führt die Transformation der Ansicht je nach Azimut und Kippung durch
			
			double temp;
			double[] KoordErg;
			KoordErg = new double[3];
			
			// Drehung um z-Achse ( x,y => x', y')
			KoordErg[0] = +Math.Cos((double)az * Math.PI / 180) * Koord[0] - Math.Sin((double) az * Math.PI / 180) * Koord[1];
			KoordErg[1] = +Math.Sin((double)az * Math.PI / 180) * Koord[0] + Math.Cos((double) az * Math.PI / 180) * Koord[1];
			
			//Zuweisung der Koordinaten in Koord
			//Koord[0] = KoordErg[0];
			temp = KoordErg[1];
			
			// Drehung um x' Achse
			KoordErg[1] = +temp * Math.Sin( (double) el * Math.PI / 180) + Koord[2] * Math.Cos( (double) el * Math.PI / 180);
			KoordErg[2] = +temp * Math.Cos( (double) el * Math.PI / 180) + Koord[2] * Math.Sin( (double) el * Math.PI / 180);
			KoordErg = tauscheYZ (ref KoordErg);
			return KoordErg;
		}
		
		
		
		private Bitmap drawVektor (ref Bitmap Graph, double[] Startpunkt, double[] Endpunkt, Color Farbe)
		{
			int i,k;
			double Auszug;
			double[] Richtung;
			int myXPixel;
			int myYPixel;
			int myXMin;
			int myXMax;
			int myYMin;
			int myYMax;
			Richtung = new double[3];
			
			bool nichtfertig;
			nichtfertig = true;
			

			// Sicherheitskopien erstellen, weil Änderungen trotz fehlendem Ref auf Original zurückgreifen
			double[] Endpunkt1;
			double[] Startpunkt1;
			Endpunkt1 = new double[3];
			Startpunkt1 = new double[3];
			Endpunkt1 = Endpunkt;
			Startpunkt1 = Startpunkt;
			
			
			// Wenn Vektor nach unten zeigt, Start & Endpunkt1 vertauschen
			if (Endpunkt1[1] < Startpunkt1[1])
			{
				for (i = 0; i < 3; i++)
				{
					Richtung[i] = Startpunkt1[i];
					Startpunkt1[i] = Endpunkt1[i];
					Endpunkt1[i] = Richtung[i];
				}
				
			}
			
			
			// Vektorrichtung bestimmen
			for (i = 0; i <3; i++)
				Richtung[i] = Endpunkt1[i] - Startpunkt1[i];
			
			
			// Wenn Anstieg mehr Richtung X
			// if ( Richtung[0] / (xmax - xmin)*(ymax - ymin) * (xVektor[1]-xVektor[0]) >= Richtung[1] * (yVektor[1]-yVektor[0]) )
			if ( Math.Abs( Richtung[0] / (xVektor[1]-xVektor[0]) ) >= Math.Abs (Richtung[1]/(yVektor[1]-yVektor[0]) ) )
			{
				// Allgemeine Vektordaten berechnen
				{// Minimale und maximale x-Position suchen
					myXMin = getVektorkoord(ref xVektor, ref Startpunkt1[0]);
					myXMax = getVektorkoord(ref xVektor, ref Endpunkt1[0]);
					if (myXMin > myXMax)
					{
						i = myXMin;
						myXMin = myXMax;
						myXMax = i;
					}
//						myXMin = Convert.ToInt16(Math.Floor(xmax));
//					if (myXMax > xmax)
//						myXMax = Convert.ToInt16(Math.Floor(xmax));
				}
				
				while (nichtfertig)
				{
					// Vektor in Pixelelemente zerlegen
					for (k = myXMin ; k <= myXMax-1; k++)
					{
						// Richtungsvektor verlängern

						// Auszug bestimmen
						Auszug = Startpunkt1[1] + ( (xVektor[k] - Startpunkt1[0]) * Richtung[1] / Richtung[0] );
						
						// Für jedes Vektorelement, Pixel zeichnen
						myXPixel = getVektorkoord(ref xVektor, ref xVektor[k]);
						myYPixel = getVektorkoord(ref yVektor, ref Auszug);
						
						
						Graph.SetPixel(Bildrand+myXPixel,Bildhoehe-Bildrand-myYPixel,Farbe);
						
					}
					nichtfertig = false;
				}
			}
			
			// Wenn Kante eher Richtung Y
			else
			{
				// Allgemeine Vektordaten berechnen
				{
					// Minimale und maximale x-Position suchen
					myYMin = getVektorkoord(ref yVektor, ref Startpunkt1[1]);
					myYMax = getVektorkoord(ref yVektor, ref Endpunkt1[1]);
				}
				
				
				while (nichtfertig)
				{
					// Vektor in Pixelelemente zerlegen
					for (k = myYMin ; k <= myYMax-1; k++)
					{
						// Richtungsvektor verlängern

						// Auszug bestimmen
						Auszug = Startpunkt1[0] + ( (yVektor[k] - Startpunkt1[1]) * Richtung[0] / Richtung[1] );
						
						// Für jedes Vektorelement, Pixel zeichnen
						myYPixel = getVektorkoord(ref yVektor, ref yVektor[k]);
						myXPixel = getVektorkoord(ref xVektor, ref Auszug);
						
						
						Graph.SetPixel(Bildrand+myXPixel,Bildhoehe-Bildrand-myYPixel,Farbe);
						
					}
					nichtfertig = false;
				}
			}
			
			
			
			
			
			
			
			return Graph;
		}
		
		
		private Bitmap drawVektorPunktLochLochLoch (ref Bitmap Graph, double[] Startpunkt, double[] Endpunkt, Color Farbe)
		{
			int i,k;
			double Auszug;

			double[] Richtung;
			int myXPixel;
			int myYPixel;
			int myXMin;
			int myXMax;
			int myYMin;
			int myYMax;

			Richtung = new double[3];
			
			bool nichtfertig;
			nichtfertig = true;
			
			// Vektor erzeugen -- Vektor beschreibt Verschiebung
			// für Auslenkung in Bildebene

			
			// Wenn Vektor nach unten zeigt, Start & Endpunkt vertauschen
			if (Endpunkt[1] < Startpunkt[1])
			{
				for (i = 0; i < 3; i++)
				{
					Richtung[i] = Startpunkt[i];
					Startpunkt[i] = Endpunkt[i];
					Endpunkt[i] = Richtung[i];
				}
				
			}
			
			
			// Vektorrichtung bestimmen
			for (i = 0; i <3; i++)
				Richtung[i] = Endpunkt[i] - Startpunkt[i];
			
			
			// Wenn Anstieg mehr Richtung X
			// if ( Richtung[0] / (xmax - xmin)*(ymax - ymin) * (xVektor[1]-xVektor[0]) >= Richtung[1] * (yVektor[1]-yVektor[0]) )
			if ( Math.Abs( Richtung[0] / (xVektor[1]-xVektor[0]) ) >= Math.Abs (Richtung[1]/(yVektor[1]-yVektor[0]) ) )
			{
				// Allgemeine Vektordaten berechnen
				{// Minimale und maximale x-Position suchen
					myXMin = getVektorkoord(ref xVektor, ref Startpunkt[0]);
					myXMax = getVektorkoord(ref xVektor, ref Endpunkt[0]);
					if (myXMin > myXMax)
					{
						i = myXMin;
						myXMin = myXMax;
						myXMax = i;
					}
//						myXMin = Convert.ToInt16(Math.Floor(xmax));
//					if (myXMax > xmax)
//						myXMax = Convert.ToInt16(Math.Floor(xmax));
				}
				
				while (nichtfertig)
				{
					// Vektor in Pixelelemente zerlegen
					for (k = myXMin ; k <= myXMax-1; k=k+3)
					{
						// Richtungsvektor verlängern

						// Auszug bestimmen
						Auszug = Startpunkt[1] + ( (xVektor[k] - Startpunkt[0]) * Richtung[1] / Richtung[0] );
						
						// Für jedes Vektorelement, Pixel zeichnen
						myXPixel = getVektorkoord(ref xVektor, ref xVektor[k]);
						myYPixel = getVektorkoord(ref yVektor, ref Auszug);
						
						
						Graph.SetPixel(Bildrand+myXPixel,Bildhoehe-Bildrand-myYPixel,Farbe);
						
					}
					nichtfertig = false;
				}
			}
			
			// Wenn Kante eher Richtung Y
			else
			{
				// Allgemeine Vektordaten berechnen
				{
					// Minimale und maximale x-Position suchen
					myYMin = getVektorkoord(ref yVektor, ref Startpunkt[1]);
					myYMax = getVektorkoord(ref yVektor, ref Endpunkt[1]);
				}
				
				
				while (nichtfertig)
				{
					// Vektor in Pixelelemente zerlegen
					for (k = myYMin ; k <= myYMax-1; k = k + 3)
					{
						// Richtungsvektor verlängern

						// Auszug bestimmen
						Auszug = Startpunkt[0] + ( (yVektor[k] - Startpunkt[1]) * Richtung[0] / Richtung[1] );
						
						// Für jedes Vektorelement, Pixel zeichnen
						myYPixel = getVektorkoord(ref yVektor, ref yVektor[k]);
						myXPixel = getVektorkoord(ref xVektor, ref Auszug);
						
						
						Graph.SetPixel(Bildrand+myXPixel,Bildhoehe-Bildrand-myYPixel,Farbe);
						
					}
					nichtfertig = false;
				}
			}
			
			
			return Graph;
		}
		
		
	
		
		private Bitmap drawPunkt (ref Bitmap Graph, double[] Startpunkt, Color Farbe)
		{
			int myXPixel;
			int myYPixel;

			
			// Vektor erzeugen -- Vektor beschreibt Verschiebung
			// für Auslenkung in Bildebene

			
			
			// Suchen der Wertstelle im Vektor
			myXPixel = getVektorkoord(ref xVektor, ref Startpunkt[0]);
			myYPixel = getVektorkoord(ref yVektor, ref Startpunkt[1]);
			
			//myXPixel = 100;
			
			Graph.SetPixel(Bildrand+myXPixel,Bildhoehe-Bildrand-myYPixel,Farbe);
			
			return Graph;
		}

		
		private int getVektorkoord (ref double[] Vektor, ref double Koord)
		{
			double j;
			int i;
			
			j = (Vektor[1] - Vektor[0]) * (Koord - Vektor[0]);
			if (j > Vektor.Length)
				return Vektor.Length;
			
			for (i = Convert.ToInt16(Math.Floor(j)) ; i < Vektor.Length; i++)
				if (Vektor[i] > Koord)
					break;
			return i;
		}
		
		private int[] getmatrixsize(ref double[,] matrix)
		{
			int[] rueckgabe;
			rueckgabe = new int[2];
			double temp = 0d;
			int i=0;
			// Erste Dimension
			try {
				for (i =0; i < 2e6; i++)
					temp = matrix[i, 0];
				
			} catch (Exception) {
				rueckgabe[0] = i-1;
			}
			// Zweite Dimension
			try {
				for (i =0; i < 2e6; i++)
					temp = matrix[0, i];
			} catch (Exception) {
				rueckgabe[1] = i-1;
			}
			return rueckgabe;
			
		}
		
		
	}
	

	
//	private class Pixelkoordinatensystem
//	{
//
//	}
	
}
